/*****************************************************************************
: avr910.

Creted by PROTTOSS
Mail to PROTTOSS@mail.ru

 AVR910

16.12.2006
******************************************************************************/

#include "stdafx.h"
#include "usbdrv.h"
#include "avr910.h"
#include "avr910devices.h"
#include <stdlib.h>

/*****************************************************************************
 
******************************************************************************/

#define SOFTWARE_VER_1				'U'
#define SOFTWARE_VER_2				'2'
#define HARDWARE_VER_1				'0'
#define HARDWARE_VER_2				'2'
#define PROGRAMMER_TYPE				'S' 	// Serial type
#define ACK							0x0D 	// 13D
#define NACK						'?'		// 0x3F
#define YES							'Y'
#define ESC							0x1B
#define OPERATION_READ				0
#define OPERATION_WRITE				1
#define MEGA						0 // mega/tiny AVR
#define CLASSIC						1 // classic AVR
#define S89							2 // 89Sxxx

#define AVR910_TX_DATA_SIZE			128
#define AVR910_REPORT_BLOCK_SIZE	128
#define AVR910_FIFO_SIZE			16
#define AVR910_FIFO_MASK			(AVR910_FIFO_SIZE - 1)

#define LOW_SCK_DELEY				300 //      20  (25 + 25 )

#define SPI_ON()	SPCR = ((1 << SPR1) | (0 << SPR0) | (1 << SPE) | (1 << MSTR))
#define SPI_OFF()	SPCR = 0

/*****************************************************************************
  ISP
******************************************************************************/
#define ISP_PORT	PORTB
#define ISP_DDR		DDRB
#define ISP_PIN		PINB

#define LED_PORT	PORTD
#define LED_PIN		PIND
#define LED_DDR		DDRD

#define PIN_LOW_SCK	0
#define PIN_CLOCK	1
#define PIN_RESET	2
#define PIN_MOSI	3
#define PIN_MISO	4
#define PIN_SCK		5
#define PIN_LED_RD	6
#define PIN_LED_WR	7

#define SET_LED_WR()	LED_PORT |=	 (1 << PIN_LED_WR)
#define CLR_LED_WR()	LED_PORT &= ~(1 << PIN_LED_WR)
#define SET_LED_RD()	LED_PORT |=	 (1 << PIN_LED_RD)
#define CLR_LED_RD()	LED_PORT &= ~(1 << PIN_LED_RD)
#define SET_RESET()		ISP_PORT |=	 (1 << PIN_RESET)
#define CLR_RESET()		ISP_PORT &= ~(1 << PIN_RESET)
#define SET_MOSI()		ISP_PORT |=	 (1 << PIN_MOSI)
#define CLR_MOSI()		ISP_PORT &= ~(1 << PIN_MOSI)
#define SET_MISO()		ISP_PORT |=	 (1 << PIN_MISO)
#define CLR_MISO()		ISP_PORT &= ~(1 << PIN_MISO)
#define SET_SCK()		ISP_PORT |=	 (1 << PIN_SCK)
#define CLR_SCK()		ISP_PORT &= ~(1 << PIN_SCK)

/*****************************************************************************
 
******************************************************************************/

UCHAR	g_DeviceType;		//   

UCHAR	g_DeviceCode;
UCHAR	g_DevicePollCode;	//       
UINT 	g_Addr; 			//    

//     USB 
BOOL	g_BlockMode;		//  /   
UINT	g_BlockSize;		//   
UCHAR	g_MemType;			//     
UCHAR	g_WordCount;		//     /   
UCHAR	g_Operation;		//    
UCHAR	g_Command;			//     
BOOL	g_NeedParams;		//    

//  FIFO  /
UCHAR	g_FIFO[AVR910_FIFO_SIZE]; //  
UCHAR	g_wrI;			//     
UCHAR	g_rdI;			//     
UCHAR	g_FIFODataSize; //    

//    USB 
UCHAR	g_txBuf[AVR910_TX_DATA_SIZE];	//   
UCHAR 	g_txWR;			//    
UCHAR	g_txRD;			//    

//  
PROGMEM UCHAR SwID[] =
{
  	'A', 'V', 'R', ' ', 'I', 'S', 'P', 0 ,
};

/*****************************************************************************
 
******************************************************************************/

//  SPI- AVR
#define AVR_L_BYTE					0x00
#define AVR_H_BYTE					0x08
#define AVR_RD_BYTE					0x20
#define AVR_WR_BYTE					0x40
#define AVR_PROG_EN()				Write123(0xAC, 0x53, 0x00)
#define AVR_CHIP_ERASE()			Write1234(0xAC, 0x80, 0x00, 0x00)
#define AVR_POLL_READY()			Write1234(0xF0, 0x00, 0x00, 0x00)
#define AVR_RD_FLASH_LB(addr)		Write1234(0x20, HIBYTE(addr), LOBYTE(addr), 0x00)
#define AVR_RD_FLASH_HB(addr)		Write1234(0x28, HIBYTE(addr), LOBYTE(addr), 0x00)
#define AVR_WR_FLASH_LB(addr, data)	Write1234(0x40, HIBYTE(addr), LOBYTE(addr), data)
#define AVR_WR_FLASH_HB(addr, data)	Write1234(0x48, HIBYTE(addr), LOBYTE(addr), data)
#define AVR_WR_FLASH_PAGE(addr)		Write1234(0x4C, HIBYTE(addr), LOBYTE(addr), 0x00)
#define AVR_RD_EEPROM(addr)			Write1234(0xA0, HIBYTE(addr), LOBYTE(addr), 0x00)
#define AVR_WR_EEPROM(addr, data)	Write1234(0xC0, HIBYTE(addr), LOBYTE(addr), data)
#define AVR_RD_LOCK()				Write1234(0x58, 0x00, 0x00, 0x00)
#define AVR_WR_LOCK(data)			Write1234(0xAC, data | 0xF9, 0x00, data)
#define AVR_RD_SIGN(addr)			Write1234(0x30, 0x00, addr, 0x00)
#define AVR_RD_FUSE()				Write1234(0x50, 0x00, 0x00, 0x00)
#define AVR_WR_FUSE(data)			Write1234(0xAC, 0xA0, 0x00, data)
#define AVR_RD_FUSE_H()				Write1234(0x58, 0x08, 0x00, 0x00)
#define AVR_WR_FUSE_H(data)			Write1234(0xAC, 0xA8, 0x00, data)
#define AVR_RD_FUSE_EXT()			Write1234(0x50, 0x08, 0x00, 0x00)
#define AVR_WR_FUSE_EXT(data)		Write1234(0xAC, 0xA4, 0x00, data)
#define AVR_RD_CALIBR(addr)			Write1234(0x38, 0xA8, addr, 0x00)

//  SPI- 89S
#define S89_ADDR_HBYTE(h_addr)		((h_addr << 3) | ((h_addr >> 3) & 0x04))
#define S89_PROG_EN()				Write123(0xAC, 0x53, 0x00)
#define S89_CHIP_ERASE()			Write123(0xAC, 0x04, 0x00)
#define S89_RD_FLASH(addr)			Write123(S89_ADDR_HBYTE(HIBYTE(addr)) | 0x01, LOBYTE(addr), 0x00)
#define S89_WR_FLASH(addr, data)	Write123(S89_ADDR_HBYTE(HIBYTE(addr)) | 0x02, LOBYTE(addr), data)
#define S89_RD_EEPROM(addr)			Write123(S89_ADDR_HBYTE(HIBYTE(addr)) | 0x05, LOBYTE(addr), 0x00)
#define S89_WR_EEPROM(addr, data)	Write123(S89_ADDR_HBYTE(HIBYTE(addr)) | 0x06, LOBYTE(addr), 0x00)
#define S89_WR_LOCK(data)			Write123(0xAC, (data & 0xE0) | 0x07, 0x00)

//     AVR
#define AVR_DELAY_RESET()		__delay_cycles(300000) // > 20 ms
#define AVR_DELAY_WR_FUSE()		__delay_cycles(150000)	// > 10 ms
#define AVR_DELAY_WR_FLASH()	__delay_cycles(150000)	// > 5 ms
#define AVR_DELAY_WR_EEPROM()	__delay_cycles(150000)	// > 10 m
#define AVR_DELAY_ERASE()		__delay_cycles(300000)	// > 20 m

//     89S
#define S89_DELAY_RESET()		__delay_cycles(150000)	// > 10 ms
#define S89_DELAY_WR_FUSE()		__delay_cycles(150000)	// > 10 ms
#define S89_DELAY_WR_FLASH()	__delay_cycles(30000)	// > 2,5 ms
#define S89_DELAY_WR_EEPROM()	__delay_cycles(30000)	// > 2,5 ms
#define S89_DELAY_ERASE()		__delay_cycles(150000)	// > 10 ms

#define DELAY_RESET()			__delay_cycles(300000)  // > 20 ms
#define DELAY_WR_FUSE()			__delay_cycles(150000) 	// > 10 ms
#define DELAY_WR_FLASH()		__delay_cycles(150000)	// > 10 ms
#define DELAY_WR_EEPROM()		__delay_cycles(150000)	// > 10 m
#define DELAY_ERASE()			__delay_cycles(300000)	// > 20 m

void AVR910_Init(void);
void AVR910_Command(UCHAR *data, UCHAR len);
UCHAR AVR910_IsRxData(UCHAR **data);
void AVR910_ClearTXData(UCHAR bytesRead);
UCHAR ExSPI(UCHAR wr_data);
void CatchPorts(void);
void ReleasePorts(void);
UCHAR GetChar(void);
void PutChar(UCHAR data);
UCHAR Write123(UCHAR byte1, UCHAR byte2, UCHAR byte3);
UCHAR Write1234(UCHAR byte1, UCHAR byte2, UCHAR byte3, UCHAR byte4);
void PollData(UCHAR command, UCHAR data);

void FIFO_Reset(void);
void FIFO_Write(UCHAR data);
UCHAR FIFO_Read(void);

void CheckCommParams(UCHAR req_bytes);

void SetProgMode(void);
void GetDevCodes(void);
void SetDevType(void);
void SetLED(void);
void ClrLED(void);
void tx123rx4(void);
void tx1234rx4(void);
void GetBlockMode(void);
void GetSWID(void);
void GetSWVer(void);
void GetHWVer(void);
void GetAutoIncAddr(void);
void SetAddr(void);
void GetPROGType(void);
void ChipErase(void);
void WriteFuse(void);
void WriteLock(void);
void ReadFuse(void);
void ReadHFuse(void);
void ReadSignature(void);
void LeaveProgMode(void);

void WriteProgLB(void);
void WriteProgHB(void);
void WriteProgOneLB(void);
void WriteProgOneHB(void);
void WritePage(void);
void ReadProg(UCHAR com_byte1, UCHAR com_byte2);
void WriteData(void);
void WriteOneData(void);
void ReadData(void);
void ReadBlockCommand(void);
void WriteBlockCommand(void);
void ReadBlock(void);
void WriteBlock(void);

/*****************************************************************************

******************************************************************************/
void AVR910_Init(void)
{	
  	//   
  	LED_DDR 	|= (1 << PIN_LED_WR) | (1 << PIN_LED_RD);
    LED_PORT	&= ~((1 << PIN_LED_WR) | (1 << PIN_LED_RD));

    //   low_sck
    ISP_PORT	|= (1 << PIN_LOW_SCK); //    
    ISP_DDR		&= ~(1 << PIN_LOW_SCK);	//   

    //  - TC1
    TCCR1A = (0 << WGM11)| (0 << WGM10)|			   // CTC
      		 (0 << COM1A1) | (1 << COM1A0);			   // Toggle OC1A on Compare Match
	TCCR1B = (0 << CS12) | (0 << CS11) | (1 << CS10) | // clkIO /1 (No prescaling)
      		 (0 << WGM13)| (1 << WGM12);			   // CTC
    OCR1A  = (UINT)5;

    //  
	ISP_DDR |= (1 << PIN_CLOCK);

    //  SPI 
    SPSR = 0x00; //  SPI2X

    //  AVR910  
  	g_Addr = 0;
    g_BlockMode = FALSE;
    g_NeedParams = FALSE;
    FIFO_Reset();
    ReleasePorts();
}

/*****************************************************************************
 
******************************************************************************/
void AVR910_Command(UCHAR *data, UCHAR len)
{	
	g_txWR = g_txRD = 0;	//   

    //     USB  FIFO 
    while(len--)
    	FIFO_Write(*data++);


    //    USB 
	while(0 < g_FIFODataSize)
    {	
      	//    
      	if(TRUE == g_BlockMode)
    	{	
          	//   (, )
          	if(OPERATION_WRITE == g_Operation)
            {	
              	//   
              	WriteBlock();
            	continue;
            }
            else
            {	
              	//     
              	//     -      
              	g_BlockMode = FALSE;
            }
   		}

        // ,    
        if(FALSE == g_NeedParams)
        	g_Command = GetChar();

      	
      	//  
      	switch(g_Command)
    	{	
        	case ESC:
            break;
			case 'P': SetProgMode();
      		break;
			case 'a': GetAutoIncAddr();
			break;
			case 'A': SetAddr();
			break;
			case 'S': GetSWID();              	
        	break;
			case 'V': GetSWVer();             	
        	break;
			case 'v': GetHWVer();
        	break;
			case 'p': GetPROGType();
        	break;
            case 'T': SetDevType();
        	break;
            case 't': GetDevCodes();
        	break;
            case 'x': SetLED();
        	break;
			case 'y': ClrLED();
        	break;
			case ':': tx123rx4();
        	break;
			case '.': tx1234rx4();
        	break;
			case 'b': GetBlockMode();
			break;
        	case 'e': ChipErase();
        	break;
            case 'L': LeaveProgMode();
        	break;
        	case 'l': WriteLock();
        	break;
			case 'f': WriteFuse();
        	break;
			case 'F': ReadFuse();
       		break;
			case 'N': ReadHFuse();
       		break;
            case 's': ReadSignature();
        	break;
            case 'd': ReadData();
        	break;
			case 'g': ReadBlockCommand();
			break;
			case 'B': WriteBlockCommand();
			break;
            case 'R': ReadProg(0x28, 0x20);
        	break;
        	case 'c': WriteProgOneLB();
            break;
			case 'C': WriteProgOneHB();
            break;
			case 'm': WritePage(); PutChar(ACK);// OK
        	break;
			case 'D': WriteOneData();
       		break;
			default: PutChar(NACK);
          	break;
    	}
		
        //      , 
        if(TRUE == g_NeedParams)
          	break;
    }
}

/*****************************************************************************
   data       
g_txLen  
******************************************************************************/
UCHAR AVR910_IsRxData(UCHAR **data)
{	
  	*data = &g_txBuf[g_txRD]; //     
  	return (g_txWR - g_txRD); //   
}

/*****************************************************************************
      USB 
  bytesRead      
.
******************************************************************************/
void AVR910_ClearTXData(UCHAR bytesRead)
{	
  	//      
    //    
    g_txRD += bytesRead;

    // ,   
    if(g_txRD == g_txWR)
    {  	
      	//  ,      
    	//       
    	g_txRD = g_txWR = 0;
		if((TRUE == g_BlockMode) &&
           (OPERATION_READ == g_Operation))
    		ReadBlock();
    }
}

/*****************************************************************************
   SPI
  SPI   wr_data      
******************************************************************************/
UCHAR ExSPI(UCHAR wr_data)
{	
  	//   low_sck
  	if(ISP_PIN & (1 << PIN_LOW_SCK)) //  ,  SPI
	{	
      	SPI_ON();	//  SPI
  		SPDR = wr_data;	//  SPI 
        while(!(SPSR & (1<<SPIF))){};	//   
		return SPDR;	//   
    }
    else //   SPI
    {	
      	UCHAR rd_data;
        SPI_OFF();	//   SPI
      	for(UCHAR i = 0; i < 8; i++)
        {	
          	//     
          	if(0 != (wr_data & 0x80))
            	ISP_PORT |= (1 << PIN_MOSI); // = 1
            else
            	ISP_PORT &= ~(1 << PIN_MOSI);	// = 0

            //   
        	wr_data <<=1;

            //   (  ) 
            //  
            rd_data <<= 1;
            if(0 != (ISP_PIN & (1 << PIN_MISO)))
            	rd_data++; //   ,    

			//     SCK 
            ISP_PORT |= (1 << PIN_SCK);	// 
            __delay_cycles(LOW_SCK_DELEY); // 
            ISP_PORT &= ~(1 << PIN_SCK);	// 
            __delay_cycles(LOW_SCK_DELEY); // 
    	}

        return rd_data;
    }
}

/*****************************************************************************
    
******************************************************************************/
void CatchPorts(void)
{	
  	//   SPI  ISP 
  	ISP_DDR  |= (1 << PIN_SCK) | (1 << PIN_MOSI) | (1 << PIN_RESET);

    //     MISO
    ISP_PORT |= (1 << PIN_MISO);

    //  SPI   
    SPI_ON();
	
    //  RESET   
    if(g_DeviceType == S89)
      	SET_RESET();
    else
      	CLR_RESET();
}

/*****************************************************************************
 
******************************************************************************/
void ReleasePorts(void)
{	
  	//  SPI
  	SPI_OFF();

    //   SPI  ISP 
  	ISP_DDR &=  ~((1 << PIN_SCK) | (1 << PIN_MISO) | (1 << PIN_MOSI) | (1 << PIN_RESET));
    ISP_PORT &= ~((1 << PIN_SCK) | (1 << PIN_MISO) | (1 << PIN_MOSI) | (1 << PIN_RESET));
}

/*****************************************************************************
     USB
******************************************************************************/
UCHAR GetChar(void)
{	
  	/*if(g_rxLen > 0)
    {	
      	g_rxLen--;
    	return *g_rxBuf++;
    }

    return 0;*/
 	return FIFO_Read(); 	
}

/*****************************************************************************
     USB
******************************************************************************/
static void PutChar(UCHAR data)
{	
  	if(g_txWR < AVR910_TX_DATA_SIZE)
      	g_txBuf[g_txWR++] = data;
}

/*****************************************************************************
  3   SPI      3-
******************************************************************************/
UCHAR Write123(UCHAR byte1, UCHAR byte2, UCHAR byte3)
{	
  	ExSPI(byte1);
    ExSPI(byte2);
    return ExSPI(byte3);
}

/*****************************************************************************
  4   SPI      4-
******************************************************************************/
UCHAR Write1234(UCHAR byte1, UCHAR byte2, UCHAR byte3, UCHAR byte4)
{	
  	ExSPI(byte1);
    ExSPI(byte2);
    ExSPI(byte3);
    return ExSPI(byte4);
}

/*****************************************************************************
   
******************************************************************************/
void SetProgMode(void)
{	
  	UCHAR err = ACK;
    SET_LED_RD();
    SET_LED_WR();
    	      	
    //   
    if(S89 == g_DeviceType) //89S
    {	
      	ReleasePorts(); //  
		CatchPorts();	//    ISP
   		S89_DELAY_RESET();	// 
          	
        //      
        S89_PROG_EN();
    }
    else
    {	
      	//    
        ReleasePorts(); 	//  
		CatchPorts();		//    ISP
   		AVR_DELAY_RESET();	// 
          	
        // 32      
        for(UCHAR c = 0; c < 32; c++)
        {	
           	//      
			//   3-   SPI      
          	UCHAR ctrl_byte = AVR_PROG_EN();
            ExSPI(0x00);
        		
            //     -  
            if(0x53 == ctrl_byte)
           		goto m1;
           		
            //    ,      
          	SET_SCK();
    		__delay_cycles(600); //  50 
			CLR_SCK();
    		__delay_cycles(600);
        }
        	
        //    ,
        // ,    
        ReleasePorts(); //  
        err = NACK; //   
    }

m1:
    PutChar(err);
    CLR_LED_WR();
    CLR_LED_RD();
}

/*****************************************************************************
   
******************************************************************************/
static void GetDevCodes(void)
{	
  	UCHAR code, i = 0;
    do
    {	
      	code = DeviceDesc[i];
      	PutChar(code);
      	i += 2;
	}
    while(0!= code);
}

/*****************************************************************************
   
     ,   
   
******************************************************************************/
static void SetDevType(void)
{	
  	UCHAR code, err = NACK, i = 0, request;

    // ,     
    CheckCommParams(1);
    if(TRUE == g_NeedParams)
      	return;

    request = GetChar();

    //         
    //      0
	while(0 != (code = DeviceDesc[i]))
    {	
      	//   ,   ,
      	//    
      	if(request == code)
        {	
          	//   
          	g_DeviceCode = DeviceDesc[i];
          	g_DevicePollCode = DeviceDesc[i + 1];
            err = ACK;
            if(0x7F < g_DeviceCode)
            	g_DeviceType = S89;
            else
              	if((g_DevicePollCode == 0x7F) ||
                   (g_DevicePollCode == 0xFF))
                	g_DeviceType = CLASSIC;
                else
                  	g_DeviceType = MEGA;
        }

        i += 2;
    }

    PutChar(err);
}

/*****************************************************************************
  
 
******************************************************************************/
static void SetLED(void)
{	
  	// ,     
    CheckCommParams(1);
    if(TRUE == g_NeedParams)
      	return;

  	GetChar();
	PutChar(ACK);
}

/*****************************************************************************
  
 
******************************************************************************/
static void ClrLED(void)
{	
  	// ,     
    CheckCommParams(1);
    if(TRUE == g_NeedParams)
      	return;

  	GetChar();
	PutChar(ACK);
}

/*****************************************************************************
 :   SPI 3      
    4- (0x00)
******************************************************************************/
static void tx123rx4(void)
{	
  	// ,     
    CheckCommParams(3);
    if(TRUE == g_NeedParams)
      	return;
  	
  	SET_LED_RD();
    SET_LED_WR();

    UCHAR b1 = GetChar();
    UCHAR b2 = GetChar();
    UCHAR b3 = GetChar();
  	PutChar(Write1234(b1, b2, b3, 0x00));
    PutChar(ACK);
    DELAY_WR_FLASH();

    CLR_LED_RD();
    CLR_LED_WR();
}

/*****************************************************************************
 :   SPI 3      
    4- (d4)
******************************************************************************/
static void tx1234rx4(void)
{	
  	// ,     
    CheckCommParams(4);
    if(TRUE == g_NeedParams)
      	return;
  	
  	SET_LED_RD();
    SET_LED_WR();

    UCHAR b1 = GetChar();
    UCHAR b2 = GetChar();
    UCHAR b3 = GetChar();
    UCHAR b4 = GetChar();
    PutChar(Write1234(b1, b2, b3, b4));
  	PutChar(ACK);
    DELAY_WR_FLASH();

    CLR_LED_RD();
    CLR_LED_WR();
}

/*****************************************************************************
   ,  
******************************************************************************/
void WriteProgLB(void)
{	
  	//   
  	SET_LED_WR();
  	
  	//   
	UCHAR data = GetChar();	

    //  
    if(g_DeviceType == S89)
    	S89_WR_FLASH(g_Addr, data);    	  	
    else
    	AVR_WR_FLASH_LB(g_Addr, data);
	
    //   
	PollData(0x20, data);

    //  ,  89S
    if(S89 == g_DeviceType)
      	g_Addr++;

    //   
    CLR_LED_WR();
}

/*****************************************************************************
   ,  
******************************************************************************/
void WriteProgHB(void)
{	
  	if(S89 != g_DeviceType)
    {	
      	//   
  		SET_LED_WR();
      	
      	//    
		UCHAR data = GetChar();
      	
      	//   SPI  
        AVR_WR_FLASH_HB(g_Addr, data);

    	//   
		PollData(0x28, data);
	
    	//  
    	g_Addr++;

        //   
    	CLR_LED_WR();
    }
}

/*****************************************************************************
    ,  
******************************************************************************/
static void WriteProgOneLB(void)
{	
  	// ,     
    CheckCommParams(1);
    if(TRUE == g_NeedParams)
      	return;
  	
  	WriteProgLB();
    PutChar(ACK); // OK
}

/*****************************************************************************
    ,  
******************************************************************************/
static void WriteProgOneHB(void)
{	
  	// ,     
    CheckCommParams(1);
    if(TRUE == g_NeedParams)
      	return;
  	
  	WriteProgHB();
    PutChar(ACK); // OK
}

/*****************************************************************************
    
******************************************************************************/
static void WriteOneData(void)
{	
  	// ,     
    CheckCommParams(1);
    if(TRUE == g_NeedParams)
      	return;
  	
  	WriteData();
    PutChar(ACK); // OK
}

/*****************************************************************************
     
******************************************************************************/
void PollData(UCHAR command, UCHAR data)
{	
  	//  
  	if(g_DevicePollCode & 0x0F)
    {	
      	//      ,     
      	if(g_DevicePollCode == data)
        	DELAY_WR_FLASH();

        else
        {	
          	// 256  
          	UCHAR cycle = 0xFF;
          	do
            {	
              	//  
              	if(S89 == g_DeviceType) // 89S
                {
                  	if(data == S89_RD_FLASH(g_Addr))
                    	break; // OK
                }
                else // AVR
                {	
                  	if(data == Write1234(command, HIBYTE(g_Addr), LOBYTE(g_Addr), 0x00))
                		break; // OK
                }
            }
            while(--cycle);

            //        (((
            if(0 == cycle)
            	DELAY_WR_FLASH();
        }
    }  	
}

/*****************************************************************************
    
******************************************************************************/
void WritePage(void)
{	
  	//   Write Programm Memory Page
  	if(MEGA == g_DeviceType) //mega/tiny AVR
    {	
      	UINT page_addr = g_Addr;
        if(TRUE == g_BlockMode)
        	page_addr--;
  		Write1234(0x4C, HIBYTE(page_addr), LOBYTE(page_addr), 0x00);
		DELAY_WR_FLASH();
    }
}

/*****************************************************************************
  
******************************************************************************/
void ReadProg(UCHAR com_byte1, UCHAR com_byte2)
{	
  	//   
  	SET_LED_RD();
  	
  	if(S89 != g_DeviceType)// AVR -  
    {	
      	PutChar(Write1234(com_byte1, HIBYTE(g_Addr), LOBYTE(g_Addr), 0x00));
        PutChar(Write1234(com_byte2, HIBYTE(g_Addr), LOBYTE(g_Addr), 0x00));
    }
    else//S89 -  
    {	
      	PutChar(S89_RD_FLASH(g_Addr));
    }
	
    //  
	g_Addr++;

    //   
  	CLR_LED_RD();
}

/*****************************************************************************
    (EEPROM)
******************************************************************************/
void WriteData(void)
{	
  	//   
  	SET_LED_WR();
  	
	//   
	UCHAR data = GetChar();

    //   
    if(S89 != g_DeviceType) // AVR
    	AVR_WR_EEPROM(g_Addr, data);
    else // 89S
    	if(0x86 == g_DeviceCode)// EEPROM    8252
           	S89_WR_EEPROM(g_Addr, data);
	
    DELAY_WR_EEPROM();

    //  
    g_Addr++;

    //   
    CLR_LED_WR();
}

/*****************************************************************************
   (EEPROM)
******************************************************************************/
void ReadData(void)
{	
  	//   
  	SET_LED_RD();
  	
  	//   
    if(S89 != g_DeviceType)// AVR
    	PutChar(Write1234(0xA0, HIBYTE(g_Addr), LOBYTE(g_Addr), 0x00));
	else
    	if(0x86 == g_DeviceCode)//S89 EEPROM    8252
        	PutChar(Write123(((HIBYTE(g_Addr) << 3) | 0x05), LOBYTE(g_Addr), 0x00));
	
    //  
	g_Addr++;

    //   
  	CLR_LED_RD();
}

/*****************************************************************************
     (EEPROM) 
******************************************************************************/
static void ChipErase(void)
{	
  	//   
  	SET_LED_WR();
  	
  	//   Chip Erase,   OK
  	if(g_DeviceType == S89)
      	S89_CHIP_ERASE();
    else
      	AVR_CHIP_ERASE();
	DELAY_ERASE();
    PutChar(ACK);

    //   
    CLR_LED_WR();
}

/*****************************************************************************
  
******************************************************************************/
static void WriteLock(void)
{	
  	// ,     
    CheckCommParams(1);
    if(TRUE == g_NeedParams)
      	return;
  	
  	//   
  	SET_LED_WR();
  	
	//   ,  lock bits,   OK
	UCHAR data = GetChar();
	if(g_DeviceType == S89)
      	S89_WR_LOCK(data);
    else
      	AVR_WR_LOCK(data);
	DELAY_WR_FUSE();
    PutChar(ACK);

    //   
    CLR_LED_WR();
}

/*****************************************************************************
  
******************************************************************************/
static void WriteFuse(void)
{	
  	// ,     
    CheckCommParams(1);
    if(TRUE == g_NeedParams)
      	return;
  	
  	//   
  	SET_LED_WR();
  	
	//   ,  fuse bits,   OK
	UCHAR err = ACK, data = GetChar();
    if(g_DeviceType == S89)
      	err = NACK;
    else
    	AVR_WR_FUSE(data);
    DELAY_WR_FUSE();
    PutChar(err);

    //   
    CLR_LED_WR();
}

/*****************************************************************************
     ( )
******************************************************************************/
static void ReadFuse(void)
{	
  	//   
  	SET_LED_RD();
  	
    // 
    PutChar((g_DeviceType == S89)? NACK: AVR_RD_FUSE());

    //   
  	CLR_LED_RD();
}

/*****************************************************************************
     ( )
******************************************************************************/
static void ReadHFuse(void)
{	
  	//   
  	SET_LED_RD();
  	
    // 
    PutChar((g_DeviceType == S89)? NACK: AVR_RD_FUSE_H());

    //   
  	CLR_LED_RD();
}

/*****************************************************************************
  
******************************************************************************/
static void ReadSignature(void)
{	
  	//   
  	SET_LED_RD();
  	
    //   Vendor, Family, Number
    UCHAR addr = 2;
    do
    {
    	PutChar((g_DeviceType == S89)?
			0xFF:(AVR_RD_SIGN(addr)));
    }
    while(addr--);

    //   
  	CLR_LED_RD();
}

/*****************************************************************************
   
******************************************************************************/
static void LeaveProgMode(void)
{	
    ReleasePorts();
  	PutChar(ACK);
}

/*****************************************************************************
    /
******************************************************************************/
static void GetBlockMode(void)
{	
  	PutChar(YES);
    PutChar((UCHAR)(AVR910_REPORT_BLOCK_SIZE >> 8));
    PutChar(AVR910_REPORT_BLOCK_SIZE & 0xFF);
}

/*****************************************************************************
  
******************************************************************************/
static void GetSWID(void)
{	
  	UCHAR PROGMEM *ptr = SwID;
  	while(0 != *ptr)
      	PutChar(*ptr++);
}

/*****************************************************************************
  
******************************************************************************/
static void GetSWVer(void)
{	
  	PutChar(SOFTWARE_VER_1);
    PutChar(SOFTWARE_VER_2);
}

/*****************************************************************************
  
******************************************************************************/
static void GetHWVer(void)
{	
  	PutChar(HARDWARE_VER_1);
    PutChar(HARDWARE_VER_2);
}

/*****************************************************************************
   
******************************************************************************/
static void GetAutoIncAddr(void)
{	
  	PutChar(ACK);
}

/*****************************************************************************
  
******************************************************************************/
static void GetPROGType(void)
{	
  	PutChar(PROGRAMMER_TYPE);
}

/*****************************************************************************
 
******************************************************************************/
static void SetAddr(void)
{	
  	// ,     
    CheckCommParams(2);
    if(TRUE == g_NeedParams)
      	return;
  	
  	g_Addr = MAKEUINT(GetChar(), GetChar());
    PutChar(ACK);
}

/*****************************************************************************
   
******************************************************************************/
static void ReadBlockCommand(void)
{	
  	// ,     
    CheckCommParams(3);
    if(TRUE == g_NeedParams)
      	return;
  	
  	//      
  	UCHAR size_h = GetChar();
    UCHAR size_l = GetChar();
    g_BlockSize = ((UINT)(size_h << 8)) | ((UINT)(size_l));
	g_MemType = GetChar();

    g_Operation = OPERATION_READ;
    g_BlockMode = TRUE;

    //   
    if(S89 != g_DeviceType)
       	if('F' == g_MemType)//    AVR  
      		g_BlockSize /= 2;
	ReadBlock();
}

/*****************************************************************************
  
******************************************************************************/
void ReadBlock(void)
{	
  	//   
    if('F' == g_MemType)//FLASH
    {	
      	//   
      	while(g_txWR < AVR910_TX_DATA_SIZE)
        {	
          	ReadProg(0x20, 0x28);
            if(0 == --g_BlockSize)
    		{	
      			g_BlockMode = FALSE;
                break;
    		}
        }

    }
    else// EEPROM
    {	
      	//   
      	while(g_txWR < AVR910_TX_DATA_SIZE)
        {	
          	ReadData();
            if(0 == --g_BlockSize)
    		{	
      			g_BlockMode = FALSE;
                break;
    		}
        }
    }
}

/*****************************************************************************
   
******************************************************************************/
static void WriteBlockCommand(void)
{	
  	// ,     
    CheckCommParams(3);
    if(TRUE == g_NeedParams)
      	return;
  	
  	//      
  	UCHAR size_h	= GetChar();
    UCHAR size_l	= GetChar();
    g_BlockSize		= ((UINT)(size_h << 8)) | ((UINT)(size_l));
    g_MemType		= GetChar();
	g_BlockMode		= TRUE;
    g_Operation		= OPERATION_WRITE;
    g_WordCount 	= 0;

    //   
    if(S89 != g_DeviceType)
       	if('F' == g_MemType)//    AVR  */
      		g_BlockSize /= 2;
}

/*****************************************************************************
   
******************************************************************************/
void WriteBlock(void)
{	
  	//   
  	if('E' == g_MemType)// EEPROM
    {	
    	//while(g_rxLen)
      	while(0 < g_FIFODataSize)
    	{	
    		WriteData();
            g_BlockSize--;
		}
	}

	if('F' == g_MemType)//Flash
    {	
       	//while(g_rxLen)
      	while(0 < g_FIFODataSize)
       	{	
       		WriteProgLB();
     		WriteProgHB();
            g_BlockSize--;
          	
            //   
            if(MEGA == g_DeviceType)
            {	
               	g_WordCount++;
              	if(g_WordCount == g_DevicePollCode)
                {	
                  	WritePage();
                    g_WordCount = 0;
                }
            }
		}
	}
	
    //   
    if(0 == g_BlockSize)
    {  	
      	//    
      	if(g_WordCount != 0)
          	
          	//    ,
          	//        
          	if('F' == g_MemType)//Flash
      			WritePage();
          	
      	// ,   
      	g_BlockMode = FALSE;
    	PutChar(ACK);
    }
}

/*****************************************************************************
 
******************************************************************************/
void FIFO_Reset(void)
{	
  	g_wrI =
    g_rdI = 0;
    g_FIFODataSize = 0;
}

/*****************************************************************************
  
******************************************************************************/
void FIFO_Write(UCHAR data)
{	
  	if(AVR910_FIFO_SIZE > g_FIFODataSize)
    {	
      	g_FIFO[g_wrI++] = data;
    	g_wrI &= AVR910_FIFO_MASK;
        g_FIFODataSize++;
    }
}

/*****************************************************************************
  
******************************************************************************/
UCHAR FIFO_Read(void)
{	
  	if(0 < g_FIFODataSize)
    {	
      	UCHAR data = g_FIFO[g_rdI++];
    	g_rdI &= AVR910_FIFO_MASK;
        g_FIFODataSize--;
        return data;
    }

  	return 0;
}

/*****************************************************************************
,       
******************************************************************************/
void CheckCommParams(UCHAR req_bytes)
{	
  	//   FIFO  ,     
  	//     
  	if(req_bytes > g_FIFODataSize)
    	g_NeedParams = TRUE;
    else
      	g_NeedParams = FALSE;      	
}


