/*****************************************************************************
: avr910.

Creted by PROTTOSS
Mail to PROTTOSS@mail.ru

 USB 

16.12.2006
******************************************************************************/

#include "usbconfig.h"
#include "usb_descriptors.h"

/**************************************************************************
Device Descriptor
**************************************************************************/
PROGMEM USB_Device_Descriptor_t USBDeviceDescriptor =
{
	sizeof(USB_Device_Descriptor_t),	/* length of descriptor in bytes */
    USBDESCR_DEVICE,	/* descriptor type */
    0x0200,		/* USB version supported */
    USB_CFG_DEVICE_CLASS,	/* device class */
    USB_CFG_DEVICE_SUBCLASS,	/* device subclass */
    0,	/* device protocol */
    8,	/* max packet size */
    USB_CFG_VENDOR_ID,  /* 2 bytes */
    USB_CFG_DEVICE_ID,  /* 2 bytes */
    USB_CFG_DEVICE_VERSION, /* 2 bytes */

#if USB_CFG_VENDOR_NAME_LEN
    1,  /* manufacturer string index */
#else
    0,  /* manufacturer string index */
#endif

#if USB_CFG_DEVICE_NAME_LEN
    2,  /* product string index */
#else
    0,  /* product string index */
#endif

#if USB_CFG_SERIAL_NUMBER_LENGTH
    3,  /* serial number string index */
#else
    0,	/* serial number string index */
#endif

	1,	/* number of configurations */
};

PROGMEM UCHAR usbDescrString0[] = {   /* language descriptor */
    4,          /* sizeof(usbDescrString0): length of descriptor in bytes */
    3,          /* descriptor type */
    0x09, 0x04, /* language index (0x0409 = US-English) */
};

#define USB_STRING_DESCRIPTOR_HEADER(stringLength) ((2*(stringLength)+2) | (3 << 8))

#if USB_CFG_VENDOR_NAME_LEN
PROGMEM UINT  usbDescrString1[] = {
    USB_STRING_DESCRIPTOR_HEADER(USB_CFG_VENDOR_NAME_LEN),
    USB_CFG_VENDOR_NAME
};
#endif
#if USB_CFG_DEVICE_NAME_LEN
PROGMEM UINT  usbDescrString2[] = {
    USB_STRING_DESCRIPTOR_HEADER(USB_CFG_DEVICE_NAME_LEN),
    USB_CFG_DEVICE_NAME
};
#endif

/**************************************************************************
CDC Descriptors Packet for Communication Port Emulation
**************************************************************************/
PROGMEM USB_CDC_CommPort_Descriptors_Packet_t USBCDCCommPortDescriptorsPacket =
{

/**************************************************************************
Configuration Descriptor
**************************************************************************/
//PROGMEM USB_Configuration_Descriptor_t USBConfigurationDescriptor =
{
    sizeof(USB_Configuration_Descriptor_t),	/* length of descriptor in bytes */
    USBDESCR_CONFIG,    /* descriptor type */
    USB_CFG_EXTERNAL_CONFIG_DESCRIPTOR_LENGH,	/* total length of data returned (including inlined descriptors) */
    2,          /* number of interfaces in this configuration */
    1,          /* index of this configuration */
    0,          /* configuration name string index */
#if USB_CFG_IS_SELF_POWERED
    USBATTR_SELFPOWER,  /* attributes */
#else
    USBATTR_BUSPOWER,   /* attributes */
#endif
    USB_CFG_MAX_BUS_POWER / 2,
},

/**************************************************************************
Interface Descriptor 0
**************************************************************************/
//PROGMEM USB_Interface_Descriptor_t USBInterfaceDescriptor0 =
{	
  	sizeof(USB_Interface_Descriptor_t),	/* length of descriptor in bytes */
    USBDESCR_INTERFACE, /* descriptor type */
    0,          /* index of this interface */
    0,          /* alternate setting for this interface */
    USB_CFG_HAVE_INTRIN_ENDPOINT,   /* endpoints excl 0: number of endpoint descriptors to follow */
    USB_CFG_INTERFACE_CLASS,
    USB_CFG_INTERFACE_SUBCLASS,
    USB_CFG_INTERFACE_PROTOCOL,
    0,
},

/**************************************************************************
CDC Header Functional Descriptor
**************************************************************************/
//PROGMEM USB_CDC_Header_Functional_Descriptor_t USBCDCHeaderFunctionalDescriptor =
{	
  	sizeof(USB_CDC_Header_Functional_Descriptor_t),	/* length of descriptor in bytes */
    0x24,	/* descriptor type */
    0,		/* header functional descriptor */
    0x0110,
},

/**************************************************************************
CDC Abstract Control Management Functional Descriptor
**************************************************************************/
//PROGMEM USB_CDC_Abstract_Control_Management_Descriptor_t USBCDCAbstractControlManagementDescriptor =
{	
  	sizeof(USB_CDC_Abstract_Control_Management_Descriptor_t),	/* length of descriptor in bytes */
    0x24,	/* descriptor type */
    2,		/* abstract control management functional descriptor */
    0x02,   /* SET_LINE_CODING,    GET_LINE_CODING, SET_CONTROL_LINE_STATE */
},

/**************************************************************************
CDC Union Functional Descriptor
**************************************************************************/
//PROGMEM USB_CDC_Union_Functional_Descriptor_t USBCDCUnionFunctionalDescriptor =
{	
  	sizeof(USB_CDC_Union_Functional_Descriptor_t),	/* length of descriptor in bytes */
    0x24,	/* descriptor type */
    6,		/* union functional descriptor */
    0,		/* CDC_COMM_INTF_ID */
    1,		/* CDC_DATA_INTF_ID */
},

/**************************************************************************
CDC Call Management Functional Descriptor
**************************************************************************/
//PROGMEM USB_CDC_Call_Management_Functional_Descriptor_t USBCDCCallManagementFunctionalDescriptor =
{	
  	sizeof(USB_CDC_Call_Management_Functional_Descriptor_t),	/* length of descriptor in bytes */
    0x24,	/* descriptor type */
    1,		/* call management functional descriptor */
    3,		/* allow management on data interface, handles call management by itself */
    1,		/* CDC_DATA_INTF_ID */
},

/**************************************************************************
In Endpoint #3 Descriptor
**************************************************************************/
//PROGMEM USB_Endpoint_Descriptor_t USB_InEndPoint3 =
{	
  	sizeof(USB_Endpoint_Descriptor_t),     /* sizeof(usbDescrEndpoint) */
    USBDESCR_ENDPOINT,  /* descriptor type = endpoint */
    0x83,        /* IN endpoint number 3 */
    0x03,        /* attrib: Interrupt endpoint */
    0x0008,      /* maximum packet size */
    100,         /* in ms */
},

/**************************************************************************
Interface Descriptor 1
**************************************************************************/
//PROGMEM USB_Interface_Descriptor_t USBInterfaceDescriptor1 =
{	
  	sizeof(USB_Interface_Descriptor_t),	/* length of descriptor in bytes */
    USBDESCR_INTERFACE, /* descriptor type */
    1,           /* index of this interface */
    0,           /* alternate setting for this interface */
    2,           /* endpoints excl 0: number of endpoint descriptors to follow */
    0x0A,        /* Data Interface Class Codes */
    0,
    0,           /* Data Interface Class Protocol Codes */
    0,           /* string index for interface */
},

/**************************************************************************
Out Endpoint #1 Descriptor
**************************************************************************/
//PROGMEM USB_Endpoint_Descriptor_t USB_OutEndPoint1 =
{	
  	sizeof(USB_Endpoint_Descriptor_t),     /* sizeof(usbDescrEndpoint) */
    USBDESCR_ENDPOINT,  /* descriptor type = endpoint */
    0x01,        /* OUT endpoint number 1 */
    0x02,        /* attrib: Bulk endpoint */
    0x0008,      /* maximum packet size */
    0,         /* in ms */
},

/**************************************************************************
In Endpoint #1 Descriptor
**************************************************************************/
//PROGMEM USB_Endpoint_Descriptor_t USB_InEndPoint1 =
{	
  	sizeof(USB_Endpoint_Descriptor_t),     /* sizeof(usbDescrEndpoint) */
    USBDESCR_ENDPOINT,  /* descriptor type = endpoint */
    0x81,        /* IN endpoint number 1 */
    0x02,        /* attrib: Bulk endpoint */
    0x0008,      /* maximum packet size */
    0,         /* in ms */
},

};

